#define F_CPU 16000000
#define CHUNK_SIZE 32
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <ctype.h>

#include "usart/usart.h"


char c;
int faruri = 0;

void timer0_init()
{
	TCCR0A |= (1 << WGM00) | (1 << WGM01) | (1 << COM0A1) | (1 << COM0B1);
	TCCR0B |= (1 << CS00);
	OCR0A = 0;
	OCR0B = 0;
}

void toggle_led()
{
	PORTD ^= (1 << PD7); 
}

ISR(USART0_RX_vect)
{
	c = USART0_receive();
	PORTA = 0;
	PORTB &= ~(1 << PB7);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB4);

	if (faruri)
		PORTB |= (1 << PB6);
	else
		PORTB &= ~(1 << PB6);

	if (c == 'a') 
	{
		//merge in fata 
		PORTA |= (1 << PA1) | (0 << PA2) | (0 << PA3) | (1 << PA4);
		PORTB |= (1 << PB0) | (1 << PB1);
	}
	else if (c == 'b') 
	{
		//merge in stanga
		PORTA |= (1 << PA1) | (0 << PA2) | (1 << PA3) | (0 << PA4);
		PORTB |= (1 << PB0) | (1 << PB1);
		PORTB |= (1 << PB5);
	}
	else if (c == 'c') 
	{
		//merge in spate
		PORTA |= (0 << PA1) | (1 << PA2) | (1 << PA3) | (0 << PA4);
		PORTB |= (1 << PB0) | (1 << PB1);
	}
	else if (c == 'd') 
	{
		//merge in stanga
		PORTA |= (0 << PA1) | (1 << PA2) | (0 << PA3) | (1 << PA4);
		PORTB |= (1 << PB0) | (1 << PB1);
		PORTB |= (1 << PB4);
	}
	else if (c == 'e')
	{
		if (faruri)
			faruri = 0;
		else
			faruri = 1;
	}
	else
	{
		toggle_led();
		PORTB &= ~(1 << PB0);
		PORTB &= ~(1 << PB1);
		PORTB |= (1 << PB7);
	}
}

int main()
{
	sei();

	//Setam pinii folositi
	DDRB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB7) | (1 << PB6) | (1 << PB5) | (1 << PB4);
	
	DDRD |= (1 << PD7);

	DDRB |= (1 << PB3) | (1 << PB4);

	//pinii pentru motoare
	DDRA |= (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4);
	PORTA = 0;

	PORTB |= (1 << PB2);

	USART0_init(8);	

	while (1)
	{
		_delay_ms(200);
		if (faruri)
			PORTB |= (1 << PB6);
		else
			PORTB &= ~(1 << PB6);
	}

	return 0;
}